#pragma once

//--------------------------------------------------------------------------------
class InputBoxDialog : public InputBoxDialogDesign
{
public:
  InputBoxDialog(wxWindow *parent, wxString const &title, wxString const &prompt);
  virtual ~InputBoxDialog();

  void SetTextValidator(wxValidator const &validator);

protected:
	virtual void OnInitDialog(wxInitDialogEvent &event);
	virtual void OKButton_OnClick(wxCommandEvent &event);

};

//--------------------------------------------------------------------------------
int InputBoxInt(int &value, wxString const &prompt, wxString const &title = _T(""), wxWindow *parent = NULL,
                int valueMin = INT_MIN, int valueMax = INT_MAX, int valueStyle = wxNUM_VAL_DEFAULT);

int InputBoxFlt(float &value, wxString const &prompt, wxString const &title = _T(""), wxWindow *parent = NULL,
                float valueMin = -FLT_MAX, float valueMax = FLT_MAX, int precision = 3, int valueStyle = wxNUM_VAL_DEFAULT);

int InputBoxDbl(double &value, wxString const &prompt, wxString const &title = _T(""), wxWindow *parent = NULL,
                double valueMin = -DBL_MAX, double valueMax = DBL_MAX, int precision = 3, int valueStyle = wxNUM_VAL_DEFAULT);

//--------------------------------------------------------------------------------
