#pragma once

#include "OscilloscopeHard.h"

//--------------------------------------------------------------------------------
/**
 * Implementation of lock in amplifier.
 */
class LockIn
{
public:
  explicit LockIn(OscilloscopeHard const &hard);

  /**
   * Run lock in.
   */
  bool Run();

  bool IsSucceeded() const { return m_succeeded; }
  float GetAmplitude(int ch) const;
  float GetPhase(int ch) const;

private:
  LockIn();                             // Default constructor is not available.
  LockIn(LockIn const &);               // Non-copyable.
  LockIn &operator = (LockIn const &);  // Non-copyable.

  OscilloscopeHard const &m_hard;
  float m_freqError;              // Frequency error between DDS output and lock in.
  bool m_succeeded;               // Flag of Lock-in success.
  float m_amplitude[MAX_CH_NUM];  // Amplitude [V].
  float m_phase[MAX_CH_NUM];      // Phase [rad].
};

//--------------------------------------------------------------------------------
