#include "stdafx.h"
#include "VoltDivDialog.h"
#include "OscilloscopeHard.h"

//------------------------------------------------------------------------
VoltDivDialog::VoltDivDialog(wxWindow *parent, SweepTable &table)
  : VoltDivDialogDesign(parent),
    m_table(table)
{
  wxArrayString voltDivTexts = OscilloscopeHard::GetVoltDivTexts();

  m_choiceVoltDivCH1->Append(voltDivTexts);
  m_choiceVoltDivCH2->Append(voltDivTexts);
  m_choiceVoltDivCH3->Append(voltDivTexts);
  m_choiceVoltDivCH4->Append(voltDivTexts);
}

VoltDivDialog::~VoltDivDialog()
{
}

void VoltDivDialog::OnInitDialog(wxInitDialogEvent &event)
{
  // Default values are last data of the sweep table.
  Measurement const &meas = m_table[m_table.GetSize() - 1];

  m_choiceVoltDivCH1->SetSelection(meas.voltDiv[CH1]);
  m_choiceVoltDivCH2->SetSelection(meas.voltDiv[CH2]);
  m_choiceVoltDivCH3->SetSelection(meas.voltDiv[CH3]);
  m_choiceVoltDivCH4->SetSelection(meas.voltDiv[CH4]);
}

void VoltDivDialog::OKButton_OnClick(wxCommandEvent &event)
{
  m_table.FillVoltDiv(CH1, m_choiceVoltDivCH1->GetSelection());
  m_table.FillVoltDiv(CH2, m_choiceVoltDivCH2->GetSelection());
  m_table.FillVoltDiv(CH3, m_choiceVoltDivCH3->GetSelection());
  m_table.FillVoltDiv(CH4, m_choiceVoltDivCH4->GetSelection());

  if (IsModal())
  {
    EndModal(wxID_OK);
  }
  else
  {
    SetReturnCode(wxID_OK);
    Show(false);
  }
}

//------------------------------------------------------------------------
